#pragma once

#include "EuroScopePlugIn.h"


class CHoldingData
{
public:

    CString     m_Callsign ;
    CString     m_PointName ;
    bool        m_Hard ;
    time_t      m_Entered ;
    time_t      m_Leave ;

} ;


class CHoldingListPlugIn :
    public EuroScopePlugIn :: CPlugIn
{
protected:

    EuroScopePlugIn :: CAircraftList        m_HoldingList ;
    CArray < CHoldingData, CHoldingData & > m_HoldingData ;

public:

    //---CHoldingListPlugIn--------------------------------------------

    CHoldingListPlugIn ( void ) ;

    //---~CHoldingListPlugIn-------------------------------------------

    virtual ~CHoldingListPlugIn ( void ) ;


    //---OnGetTagItem---------------------------------------------------

    virtual void    OnGetTagItem ( EuroScopePlugIn :: CAircraft Aircraft,
                                   int ItemCode,
                                   int TagData,
                                   char sItemString [ 16 ],
                                   int * pColorCode,
                                   COLORREF * pRGB,
                                   double * pFontSize ) ;
    //-----------------------------------------------------------------
    //  Description :
    //      The tag item creator.
    //-----------------------------------------------------------------


    //---OnCompileCommand-----------------------------------------------

    virtual bool    OnCompileCommand ( const char * sCommandLine ) ;
    //------------------------------------------------------------------
    //  Inherited from CPlugIn
    //------------------------------------------------------------------


    //---OnAircraftControllerAssignedDataUpdate------------------------

    virtual void    OnAircraftControllerAssignedDataUpdate ( EuroScopePlugIn :: CAircraft Aircraft,
                                                             int DataType ) ;
    //------------------------------------------------------------------
    //  Inherited from CPlugIn
    //------------------------------------------------------------------


    //---OnFunctionCall-------------------------------------------------

    virtual void    OnFunctionCall ( int FunctionId,
                                     const char * sItemString,
                                     POINT Pt,
                                     RECT Area ) ;
    //------------------------------------------------------------------
    //  Inherited from CPlugIn
    //------------------------------------------------------------------

protected:

    //---_SelectAcIndex-------------------------------------------------

    int     _SelectAcIndex ( const char * sCallsign ) ;
    //------------------------------------------------------------------
    //  Parameters :
    //      =>  sCallsign   - the callsign of the AC
    //
    //  Return :
    //      The index of the AC in the holding data array (or -1)
    //------------------------------------------------------------------

};
