// PARSettingsDialog.cpp : implementation file
//

#include "stdafx.h"
#include "PrecisionApproachPlugin.h"
#include "PARSettingsDialog.h"
#include "EuroScopePlugIn.h"


// CPARSettingsDialog dialog

IMPLEMENT_DYNAMIC(CPARSettingsDialog, CDialog)

CPARSettingsDialog::CPARSettingsDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPARSettingsDialog::IDD, pParent)
    , m_Description(_T(""))
    , m_Longitude(_T(""))
    , m_Latitude(_T(""))
    , m_Altitude(0)
    , m_Heading(0)
    , m_Slope(0)
    {

}

CPARSettingsDialog::~CPARSettingsDialog()
{
}

void CPARSettingsDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Text ( pDX, IDC_DESCR_EDIT, m_Description ) ;
    DDX_Text ( pDX, IDC_LONGITUDE_EDIT, m_Longitude ) ;
    DDX_Text ( pDX, IDC_LATITUDE_EDIT, m_Latitude ) ;
    DDX_Text ( pDX, IDC_ALTITUDE_EDIT, m_Altitude ) ;
    DDV_MinMaxInt ( pDX, m_Altitude, -500, 5000 ) ;
    DDX_Text ( pDX, IDC_HEADING_EDIT, m_Heading ) ;
    DDV_MinMaxInt ( pDX, m_Heading, 0, 359 ) ;
    DDX_Text ( pDX, IDC_GLIDE_ANGLE_EDIT, m_Slope ) ;
    DDV_MinMaxDouble ( pDX, m_Slope, 1, 10 ) ;
}


BEGIN_MESSAGE_MAP(CPARSettingsDialog, CDialog)
    ON_BN_CLICKED(IDOK, &CPARSettingsDialog::OnBnClickedOk)
END_MESSAGE_MAP()


// CPARSettingsDialog message handlers

void CPARSettingsDialog::OnBnClickedOk()
{
    // get the data
    if ( ! UpdateData ())
        return ;

    // test the data
    if ( m_Description.IsEmpty ())
        {
        AfxMessageBox ( "Description field can not be empty" ) ;
        return ;
        }
    if ( m_Longitude.IsEmpty ())
        {
        AfxMessageBox ( "Longitude field can not be empty" ) ;
        return ;
        }
    if ( m_Latitude.IsEmpty ())
        {
        AfxMessageBox ( "Latitude field can not be empty" ) ;
        return ;
        }
    EuroScopePlugIn :: CPosition    pos ;
    if ( ! pos.LoadFromStrings ( m_Longitude, m_Latitude ))
        {
        AfxMessageBox ( "Syntax error in the longitude/latitude fields" ) ;
        return ;
        }

    // OK, leave
    OnOK () ;
}
