#include "StdAfx.h"
#include "PrecisionApproachPlugIn2.h"
#include "PrecisionApproachScreen.h"

#define MY_PLUGIN_NAME      "Precision Approach Radar"
#define MY_PLUGIN_VERSION   "1.0"
#define MY_PLUGIN_DEVELOPER "Gergely Csernak"
#define MY_PLUGIN_COPYRIGHT "Free to be distributed as source code"
#define MY_PLUGIN_VIEW      "Precision Approach View"


//---CPrecisionApproachPlugIn------------------------------------------

CPrecisionApproachPlugIn::CPrecisionApproachPlugIn( void )
                    : CPlugIn ( EuroScopePlugIn :: COMPATIBILITY_CODE,
                                MY_PLUGIN_NAME,
                                MY_PLUGIN_VERSION,
                                MY_PLUGIN_DEVELOPER,
                                MY_PLUGIN_COPYRIGHT )
{
    // register my own view type
    RegisterDisplayType ( MY_PLUGIN_VIEW,
                          false,        // no radar content here
                          false,        // no geo referencing
                          true,         // it can be saved to an ASR file
                          true ) ;      // can be created
}


//---~CPrecisionApproachPlugIn-----------------------------------------

CPrecisionApproachPlugIn::~CPrecisionApproachPlugIn(void)
{
}


//---OnRadarScreenCreated----------------------------------------------

EuroScopePlugIn :: CRadarScreen * CPrecisionApproachPlugIn :: OnRadarScreenCreated ( const char * sDisplayName,
                                                                                     bool NeedRadarContent,
                                                                                     bool GeoReferenced,
                                                                                     bool CanBeSaved,
                                                                                     bool CanBeCreated )
{
    // just for my view
    if ( strcmp ( sDisplayName, MY_PLUGIN_VIEW ))
        return NULL ;
    else
        return new CPrecisionApproachScreen ;
}

