#pragma once

#include "EuroScopePlugIn.h"

class CPrecisionApproachScreen :
    public EuroScopePlugIn :: CRadarScreen
{
protected:

    CString     m_Description ;                // PAP radar description
    CString     m_Latitude, m_Longitude ;      // the saved coordinates
    int         m_Altitude ;                       // treshold altitude
    int         m_Heading ;                              // RWY heading
    double      m_Slope ;                               // slope degree

    EuroScopePlugIn :: CPosition    m_RwyPos ;          // RWY treshold
    int         m_MaxHeight ;            // the max height of the slope

public:
    
    //---CPrecisionApproachScreen--------------------------------------

    CPrecisionApproachScreen ( void ) ;


    //---~CPrecisionApproachScreen-------------------------------------

    virtual ~CPrecisionApproachScreen ( void ) ;


    //---OnAsrContentLoaded--------------------------------------------

    virtual void    OnAsrContentLoaded ( bool Loaded ) ;
    //------------------------------------------------------------------
    //  When data is fully loaded.
    //------------------------------------------------------------------


    //---OnAsrContentToBeSaved------------------------------------------

    virtual void    OnAsrContentToBeSaved ( void ) ;
    //------------------------------------------------------------------
    //  When data is to be saved.
    //------------------------------------------------------------------


    //---OnRefresh------------------------------------------------------

    virtual void    OnRefresh ( HDC hDC,
                                int Phase ) ;
    //------------------------------------------------------------------
    //  The screen refresh function.
    //------------------------------------------------------------------


    //---OnCompileCommand-----------------------------------------------

    virtual bool    OnCompileCommand ( const char * sCommandLine ) ;
    //------------------------------------------------------------------
    //  The radar command compiler.
    //------------------------------------------------------------------


    //---OnAsrContentToBeClosed-----------------------------------------

    inline  virtual void    OnAsrContentToBeClosed ( void )
        {
        delete this ;
        } ;

} ;
